"""
The `statemonadtree` module provides mixin classes and constructor functions for building tree-like structures 
that represent state monad operations. These structures facilitate the composition of stateful computations in a 
hierarchical manner, where each node represents an operation applied to the state.

To simplify the construction of such monadic trees, the `statemonad` module complements this with a more convenient 
dot notation, offering intuitive methods defined in the `StateMonad` class. This combination allows for cleaner and 
more expressive handling of complex state transitions.
"""